// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from grid_map_msgs:srv/ProcessFile.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "grid_map_msgs/srv/process_file.h"


#ifndef GRID_MAP_MSGS__SRV__DETAIL__PROCESS_FILE__STRUCT_H_
#define GRID_MAP_MSGS__SRV__DETAIL__PROCESS_FILE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'file_path'
// Member 'topic_name'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/ProcessFile in the package grid_map_msgs.
typedef struct grid_map_msgs__srv__ProcessFile_Request
{
  rosidl_runtime_c__String file_path;
  /// For ROS bags: topic name that should be processed (optional).
  rosidl_runtime_c__String topic_name;
} grid_map_msgs__srv__ProcessFile_Request;

// Struct for a sequence of grid_map_msgs__srv__ProcessFile_Request.
typedef struct grid_map_msgs__srv__ProcessFile_Request__Sequence
{
  grid_map_msgs__srv__ProcessFile_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grid_map_msgs__srv__ProcessFile_Request__Sequence;

// Constants defined in the message

/// Struct defined in srv/ProcessFile in the package grid_map_msgs.
typedef struct grid_map_msgs__srv__ProcessFile_Response
{
  /// True if file processing was successful.
  bool success;
} grid_map_msgs__srv__ProcessFile_Response;

// Struct for a sequence of grid_map_msgs__srv__ProcessFile_Response.
typedef struct grid_map_msgs__srv__ProcessFile_Response__Sequence
{
  grid_map_msgs__srv__ProcessFile_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grid_map_msgs__srv__ProcessFile_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  grid_map_msgs__srv__ProcessFile_Event__request__MAX_SIZE = 1
};
// response
enum
{
  grid_map_msgs__srv__ProcessFile_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/ProcessFile in the package grid_map_msgs.
typedef struct grid_map_msgs__srv__ProcessFile_Event
{
  service_msgs__msg__ServiceEventInfo info;
  grid_map_msgs__srv__ProcessFile_Request__Sequence request;
  grid_map_msgs__srv__ProcessFile_Response__Sequence response;
} grid_map_msgs__srv__ProcessFile_Event;

// Struct for a sequence of grid_map_msgs__srv__ProcessFile_Event.
typedef struct grid_map_msgs__srv__ProcessFile_Event__Sequence
{
  grid_map_msgs__srv__ProcessFile_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grid_map_msgs__srv__ProcessFile_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // GRID_MAP_MSGS__SRV__DETAIL__PROCESS_FILE__STRUCT_H_
