// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from grid_map_msgs:srv/GetGridMap.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "grid_map_msgs/srv/get_grid_map.h"


#ifndef GRID_MAP_MSGS__SRV__DETAIL__GET_GRID_MAP__STRUCT_H_
#define GRID_MAP_MSGS__SRV__DETAIL__GET_GRID_MAP__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'frame_id'
// Member 'layers'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/GetGridMap in the package grid_map_msgs.
typedef struct grid_map_msgs__srv__GetGridMap_Request
{
  rosidl_runtime_c__String frame_id;
  /// Requested submap position in x-direction.
  double position_x;
  /// Requested submap position in y-direction.
  double position_y;
  /// Requested submap length in x-direction.
  double length_x;
  /// Requested submap width in y-direction.
  double length_y;
  /// Requested layers. If empty, get all layers.
  rosidl_runtime_c__String__Sequence layers;
} grid_map_msgs__srv__GetGridMap_Request;

// Struct for a sequence of grid_map_msgs__srv__GetGridMap_Request.
typedef struct grid_map_msgs__srv__GetGridMap_Request__Sequence
{
  grid_map_msgs__srv__GetGridMap_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grid_map_msgs__srv__GetGridMap_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'map'
#include "grid_map_msgs/msg/detail/grid_map__struct.h"

/// Struct defined in srv/GetGridMap in the package grid_map_msgs.
typedef struct grid_map_msgs__srv__GetGridMap_Response
{
  /// Submap
  grid_map_msgs__msg__GridMap map;
} grid_map_msgs__srv__GetGridMap_Response;

// Struct for a sequence of grid_map_msgs__srv__GetGridMap_Response.
typedef struct grid_map_msgs__srv__GetGridMap_Response__Sequence
{
  grid_map_msgs__srv__GetGridMap_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grid_map_msgs__srv__GetGridMap_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  grid_map_msgs__srv__GetGridMap_Event__request__MAX_SIZE = 1
};
// response
enum
{
  grid_map_msgs__srv__GetGridMap_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/GetGridMap in the package grid_map_msgs.
typedef struct grid_map_msgs__srv__GetGridMap_Event
{
  service_msgs__msg__ServiceEventInfo info;
  grid_map_msgs__srv__GetGridMap_Request__Sequence request;
  grid_map_msgs__srv__GetGridMap_Response__Sequence response;
} grid_map_msgs__srv__GetGridMap_Event;

// Struct for a sequence of grid_map_msgs__srv__GetGridMap_Event.
typedef struct grid_map_msgs__srv__GetGridMap_Event__Sequence
{
  grid_map_msgs__srv__GetGridMap_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grid_map_msgs__srv__GetGridMap_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // GRID_MAP_MSGS__SRV__DETAIL__GET_GRID_MAP__STRUCT_H_
